# Copyright (c) 1991-2003 Rational Software Corporation. All rights
# reserved.
# 
# Rational, the Rational logo, ObjecTime (and logo) are registered
# trademarks of Rational Software Corporation.
# 
# The placing of the copyright notices on Rational source code is not
# intended to mean that they are published works, but are included in the
# event of inadvertent publication. The source code of Rational contains
# trade secrets and other valuable confidential information of Rational
# Software Corporation. Rational Software Corporation and its licensors
# retain ownership to Rational Products in both source and object code
# format, and related documentation and all rights therein including
# copyrights, patents and trade secrets.
# 
# 
# U.S. Government Rights
# 
# Use, duplication, or disclosure by the U.S. Government is subject to
# restrictions set forth in the applicable Rational License Agreement
# and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
# 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
# or FAR 52.227-14, as applicable.
# 
# Unless otherwise agreed to in writing, use of Rational products is
# governed by the Rational Product License Agreement provided with
# the product.

require 'tools/registry.pl';

$sdkKey = 'HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\CEStudio\\3.0\\Setup';
$sdkSub = 'Windows CE Tools Dir';

$wceKey = "$sdkKey\\eMbedded Visual C++";
$wceSub = 'ProductDir';

$OSVERSION = 'WCE300';
$PLATFORM  = 'ms pocket pc';

unless( $SDKROOT = &ReadRegEntry( $sdkKey, $sdkSub, '' ) )
{
    print STDERR "Can't find registry SDK location '$sdkSub' at\n$sdkKey\n\n";
    exit 1;
}

unless( $WCEROOT = &ReadRegEntry( $wceKey, $wceSub, '' ) )
{
    print STDERR "Can't find registry WCE location '$wceSub' at\n$wceKey\n\n";
    exit 1;
}

{
    # Convenience variables, not exported
    my $sdk_ver_plat = "$SDKROOT\\$OSVERSION\\$PLATFORM";
    my $target       = 'mips';

    $ENV{'INCLUDE'} =  "$sdk_ver_plat\\INCLUDE"
		    . ";$sdk_ver_plat\\MFC\\INCLUDE"
		    . ";$sdk_ver_plat\\ATL\\INCLUDE";

    $ENV{'LIB'}     =  "$sdk_ver_plat\\LIB\\$target"
		    . ";$sdk_ver_plat\\MFC\\LIB\\$target"
		    . ";$sdk_ver_plat\\ATL\\LIB\\$target";

    $ENV{'PATH'}    =  "$WCEROOT\\COMMON\\EVC\\BIN"
		    . ";$WCEROOT\\EVC\\$OSVERSION\\BIN"
		    . ";$ENV{'PATH'}";
}

$ENV{'OSVERSION'} = $OSVERSION;
$ENV{'PLATFORM'}  = $PLATFORM;
$ENV{'SDKROOT'}   = $SDKROOT;
$ENV{'WCEROOT'}   = $WCEROOT;

$ENV{'CC'}        = 'clmips.exe';
$ENV{'TARGETCPU'} = 'MIPS';
$ENV{'CFG'}       = 'none';

$include_opt  = '/I';
@make_args    = ( '/nologo', '/f', '..\src\main.nmk' );
$object_ext   = '.OBJ';
$preprocessor = "$ENV{CC} /nologo /EP /P";
$target_base  = 'WINCE,NT40';
$supported    = 'No';
