#!/usr/local/bin/bin.sun4-Solaris/perl -w

# Copyright (c) 1991-2003 Rational Software Corporation. All rights
# reserved.
# 
# Rational, the Rational logo, ObjecTime (and logo) are registered
# trademarks of Rational Software Corporation.
# 
# The placing of the copyright notices on Rational source code is not
# intended to mean that they are published works, but are included in the
# event of inadvertent publication. The source code of Rational contains
# trade secrets and other valuable confidential information of Rational
# Software Corporation. Rational Software Corporation and its licensors
# retain ownership to Rational Products in both source and object code
# format, and related documentation and all rights therein including
# copyrights, patents and trade secrets.
# 
# 
# U.S. Government Rights
# 
# Use, duplication, or disclosure by the U.S. Government is subject to
# restrictions set forth in the applicable Rational License Agreement
# and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
# 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
# or FAR 52.227-14, as applicable.
# 
# Unless otherwise agreed to in writing, use of Rational products is
# governed by the Rational Product License Agreement provided with
# the product.

# Win9x command.com does not interact with perl according to win32 standard.
# We therefore need to call some functions in a non-standard way.
#
# This detects if the system is Win95 for that purpose.

sub mySystem
{
    my( $OS, $ROSERT_HOST );

    $OS          = '?' unless $OS          = $ENV{'OS'};
    $ROSERT_HOST = '?' unless $ROSERT_HOST = $ENV{'ROSERT_HOST'};

    if( $ROSERT_HOST eq 'win32' && $OS !~ m{^Windows_NT$}i )
    {
        return system( join( ' ', @_ ) );
    }
    else
    {
        return system( @_ );
    }
}

$cmd_file    = 'ram.dld';

if( ! open OUT, ">$cmd_file" )
{
    print STDERR "ld.pl: Can't create $cmd_file\n";
    exit 1;
}

@cmd = ( "" );

while( $#ARGV >= 0 )
{
    $arg = $ARGV[ 0 ];

    # Arguments -lk_file point to linker command files that need to be
    # concatenated into our command file.
    if( $arg =~ m{^-lk_file=(.*)$} )
    {
	if( ! open LK_IN, "<$1" )
	{
	    print STDERR "ld.pl: Can't open $1\n";
	    exit 1;
	}

	while( $line = <LK_IN> )
	{
	    print OUT $line;
	}

	close LK_IN;
    }
    else
    {
	push( @cmd, $arg );
    }

    shift;
}

# Read the commad file.
push( @cmd, "-Wm" );
push( @cmd, "$cmd_file" );

# Produce map file.
push( @cmd, "-m2" );
push( @cmd, ">" );
push( @cmd, "ram.map" );

close OUT;

$status = mySystem( @cmd );
unlink $cmd_file;
exit $status / 256;
