# Copyright (c) 1991-2003 Rational Software Corporation. All rights
# reserved.
# 
# Rational, the Rational logo, ObjecTime (and logo) are registered
# trademarks of Rational Software Corporation.
# 
# The placing of the copyright notices on Rational source code is not
# intended to mean that they are published works, but are included in the
# event of inadvertent publication. The source code of Rational contains
# trade secrets and other valuable confidential information of Rational
# Software Corporation. Rational Software Corporation and its licensors
# retain ownership to Rational Products in both source and object code
# format, and related documentation and all rights therein including
# copyrights, patents and trade secrets.
# 
# 
# U.S. Government Rights
# 
# Use, duplication, or disclosure by the U.S. Government is subject to
# restrictions set forth in the applicable Rational License Agreement
# and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
# 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
# or FAR 52.227-14, as applicable.
# 
# Unless otherwise agreed to in writing, use of Rational products is
# governed by the Rational Product License Agreement provided with
# the product.

VENDOR        = Diab

AR_CMD        = $(PERL) $(RTS_HOME)/tools/ar.pl -add=dar,r -create=dar,rc \
		-limit=2000
CC            = dcc

# Use three linker command files: bsp.lk, heap.lk, and oil.lk.
LD            = $(PERL) $(RTS_HOME)/libset/$(LIBRARY_SET)/ld.pl \
		-lk_file=$(OSEKWORKS)/bsp/$(CPU)/$(BOARD)/bsp.lk \
		-lk_file=$(RTS_HOME)/libset/$(LIBRARY_SET)/heap.lk \
		-lk_file=$(RTS_LIBRARY)/oil.lk \
		dld

# -t PPC555EH   PPC555: CPU
#               E:      ELF object format
#               H:      Hardware floating point

LIBSETCCFLAGS = -t PPC555EH -DOIL_H_GENERATED -Xstruct-best-align=0 -Xansi -Xkill-reorder=1 -Xkill-reorder=8 -Xpass-source -Xsmall-data=65536 -Xsmall-const=65536 -Xfar-code-relative -Xstring-align=1

# -Xmemory-is-volatile - removes optimization that assumes memory is
# only modified by application

EXEC_EXT = .elf

DEBUG_TAG     = -g -Xdebug-struct-all

# -Xlint=0x40: Generate Lint warnings except for those because of useless
#              variable assignment.

# Optimized
LIBSETCCEXTRA = -XO -Xmemory-is-volatile -Xlint=0x40

# For debugging
# LIBSETCCEXTRA = -g -Xdebug-struct-all -Xlint=0x40

LIBSETLDFLAGS = -t PPC555EH -Xelf -Xsupress-dot -limpl -lc \
		$(RTS_LIBRARY)/oil.o $(DIABLIB)/PPCE/crt0.o \
 		$(OSEKWORKS)/bsp/$(CPU)/$(BOARD)/obj/begin.o \
 		$(OSEKWORKS)/bsp/$(CPU)/$(BOARD)/libbsp.a

SHLIBS        =
