/*
 * Copyright (c) 1991-2003 Rational Software Corporation. All rights
 * reserved.
 * 
 * Rational, the Rational logo, ObjecTime (and logo) are registered
 * trademarks of Rational Software Corporation.
 * 
 * The placing of the copyright notices on Rational source code is not
 * intended to mean that they are published works, but are included in the
 * event of inadvertent publication. The source code of Rational contains
 * trade secrets and other valuable confidential information of Rational
 * Software Corporation. Rational Software Corporation and its licensors
 * retain ownership to Rational Products in both source and object code
 * format, and related documentation and all rights therein including
 * copyrights, patents and trade secrets.
 * 
 * 
 * U.S. Government Rights
 * 
 * Use, duplication, or disclosure by the U.S. Government is subject to
 * restrictions set forth in the applicable Rational License Agreement
 * and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
 * 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
 * or FAR 52.227-14, as applicable.
 * 
 * Unless otherwise agreed to in writing, use of Rational products is
 * governed by the Rational Product License Agreement provided with
 * the product.
 */

#include <RTPriv/RTthread.h>
#include <RTPriv/Task.h>

#include <RTPubl/Main.h>
#include <RTPubl/PeerCont.h>
#include <RTPubl/SyncObj.h>

#if USE_THREADS
#include <RTPubl/SystDesc.h>
#include <RTPubl/ThrdDesc.h>
#endif

extern RTTask RTTasks[ RT_OSEK_NUM_TASKS ];
extern int RTMain_mainLine_init( void );

static RTAction mainInitAction;

int RTMain_runThread( void )
{
#if USE_THREADS
    unsigned int mainPrio = RTMain_system()->constThreads[ 0 ].Priority;
#endif

    mainInitAction.exec = (void( * )( void * ))RTMain_mainLine_init;
    mainInitAction.arg = (void *)0;

    /* No other tasks are running yet - no locking is needed. */
    RTTask_unlockQueues(); /* Make sure that actions can get enqueued. */
#if USE_THREADS
    RTTask_enqueueAction( &RTTasks[ mainPrio ], &mainInitAction );

    /* Activate the main task if the main task is not this task. */
    if( mainPrio != 0 )
	ActivateTask( RTTasks[ mainPrio ]._id );
#else
    RTTask_enqueueAction( &RTTasks[ 0 ], &mainInitAction );
#endif

    return 0;
}
