#!/usr/local/bin/bin.sun4-Solaris/perl -w

# Copyright (c) 1991-2003 Rational Software Corporation. All rights
# reserved.
# 
# Rational, the Rational logo, ObjecTime (and logo) are registered
# trademarks of Rational Software Corporation.
# 
# The placing of the copyright notices on Rational source code is not
# intended to mean that they are published works, but are included in the
# event of inadvertent publication. The source code of Rational contains
# trade secrets and other valuable confidential information of Rational
# Software Corporation. Rational Software Corporation and its licensors
# retain ownership to Rational Products in both source and object code
# format, and related documentation and all rights therein including
# copyrights, patents and trade secrets.
# 
# 
# U.S. Government Rights
# 
# Use, duplication, or disclosure by the U.S. Government is subject to
# restrictions set forth in the applicable Rational License Agreement
# and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
# 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
# or FAR 52.227-14, as applicable.
# 
# Unless otherwise agreed to in writing, use of Rational products is
# governed by the Rational Product License Agreement provided with
# the product.

# Win9x command.com does not interact with perl according to win32 standard.
# We therefore need to call some functions in a non-standard way.
#
# This detects if the system is Win95 for that purpose.

sub mySystem
{
    my( $OS, $ROSERT_HOST );

    $OS          = '?' unless $OS          = $ENV{'OS'};
    $ROSERT_HOST = '?' unless $ROSERT_HOST = $ENV{'ROSERT_HOST'};

    if( $ROSERT_HOST eq 'win32' && $OS !~ m{^Windows_NT$}i )
    {
        return system( join( ' ', @_ ) );
    }
    else
    {
        return system( @_ );
    }
}

sub show_usage
{
    print STDERR "Usage: oil.pl <oil file> <configuration name> <target_base>\n";
    exit 1;
}

&show_usage() unless $#ARGV >= 2;

$board       = $ENV{'BOARD'};
$wind_base   = $ENV{'WIND_BASE'};
$oil_file    = $ARGV[ 0 ];
$config_name = $ARGV[ 1 ];
$target_base = $ARGV[ 2 ];
$tgt_dir     = "../lib/$config_name";

@tgt_bases = split /,/, $target_base;
$tgt_bases_includes = "";
foreach $base (@tgt_bases)
{
    $tgt_bases_includes .= " -I ../src/target/$base"
}

$oil_cmd = "oilreader -t ppc -b $board -I $wind_base/target/osekworks/sys/oilfiles $tgt_bases_includes  -o $tgt_dir $oil_file";

if( mySystem( $oil_cmd ) )
{
    exit( 1 );
}

# -Xlint=0x08:       Generate Lint warnings except for those caused by 
#                    conditions that are always true/false.
# -ei2309,1516,1481: Ignore warnings
#                    2309 (directive not understood)
#                    1516 (parameter never used)
#                    1481 (function not declared)

$cc_cmd = "dcc -I$wind_base/target/osekworks/sys/ppc/../src_oil -I$wind_base/target/osekworks/bsp/ppc/$board/src_oil_bsp -t PPC555EH -DOIL_H_GENERATED -XO -Xstruct-best-align=0 -Xansi -Xkill-reorder=1 -Xkill-reorder=8 -Xpass-source -Xsmall-data=65536 -Xsmall-const=65536 -Xfar-code-relative -Xstring-align=1 -Xlint=0x08 -ei2309,1516,1481 -I$tgt_dir -I$wind_base/target/osekworks/include -I$wind_base/target/osekworks/bsp/ppc/$board/src/include -o $tgt_dir/oil.o -c $tgt_dir/oil.c";

if( mySystem( $cc_cmd ) )
{
    exit( 1 );
}
