# -----------------------------------------------------------------------------
sub ErrorExit 
{
    print "$0: @_\n";
    exit 1;
}


# -----------------------------------------------------------------------------
# Parse required parameters into global vars.  Parameters may/may not be 
# separated from the flag with the space.
#
sub parseParms
{
	if( @ARGV != 2 )
	{
		ErrorExit( "Insufficient parameters\n" );
	}
	
  	$BaseFile = $ARGV[0];
	$RoseRTVer = $ARGV[1];
}
#
# -----------------------------------------------------------------------------
# Verify that all required parameters are present and valid
#
sub VerifyParms
{
    ErrorExit( "Must specify File name" ) unless( $BaseFile );
}

#
# -----------------------------------------------------------------------------
# Open a model file and insert RoseRT version in it
# RATLC00516778
#

sub main
{
	&parseParms();
	&VerifyParms();
	
	if (not -r "$BaseFile")
	{
		ErrorExit ("Cannot access file: $BaseFile");
	}
	
	$TempFile = $BaseFile . "_tmp";

	open (FILE1, "<$BaseFile");
	open (FILE2, ">$TempFile");
	
	while (<FILE1>)
	{
		if ( /(^\s*_written \"Rose RealTime\s+)(.+)/ ) 
		{
			(print FILE2 "\t_written \"")		or die "can't write to $FILE2: $!";
			(print FILE2 $RoseRTVer)		or die "can't write to $FILE2: $!";
			(print FILE2 "\"\n")		or die "can't write to $FILE2: $!";
			break;
		}
		else
		{
			(print FILE2 $_)		or die "can't write to $FILE2: $!";
		}
	}

     my $chunk = '';
     while(read(FILE1, $chunk, 4096)) {
 		write( FILE2, $chunk);
     }

	close (FILE2);
	close (FILE1);

	chmod 0777, $BaseFile;
	rename 	$TempFile, $BaseFile;
			
	exit 0; 

}

# -----------------------------------------------------------------------------
#
&main();
#

